 // KasBot V1  -  Main module       basic version, angles in Quids, 10 bit ADC
//

#include <math.h>

#define   GYR_Y                 3                              // Gyro Y (IMU pin #4)
#define   ACC_Z                 2                              // Acc  Z (IMU pin #7)
#define   ACC_X                 0                              // Acc  X (IMU pin #9)

#define   PWM_R                 5                              // PWM right motor pin
#define   PWM_L                 6                              // PWM left motor pin

int   STD_LOOP_TIME  =          9;   // ms

int sensorValue[4]  = { 0, 0, 0, 0};
int sensorZero[4]  = { 0, 0, 0, 0 }; 
int lastLoopTime = STD_LOOP_TIME;
int lastLoopUsefulTime = STD_LOOP_TIME;
unsigned long loopStartTime = 0;
float actAngle;                                                  // angles in QUIDS (360° = 2PI = 1204 QUIDS   <<<
int ACC_angle;
int GYRO_rate;
int setPoint = 0;
int drive = 0;

void setup() {
  analogReference(EXTERNAL);                                              // Aref 3.3V
  Serial.begin(57600);
  
  for(int i=4;i<=7;i++)    //For Arduino Motor Shield
  pinMode(i, OUTPUT);  //set pin 4,5,6,7 to output mode
  delay(100);                                                
  calibrateSensors();
}

void loop() {
  
// ********************* Sensor aquisition & filtering *******************
  updateSensors();
  ACC_angle = getAccAngle();                                                 // in Quids
  GYRO_rate = getGyroRate();                                                 // in Quids/seconds
  actAngle = kalmanCalculate(ACC_angle, GYRO_rate, lastLoopTime);            // calculate Absolute Angle

// *********************** PID and motor drive *****************
  drive = updatePid(setPoint, actAngle);                                      // PID algorithm

  if(actAngle>(setPoint-128) && actAngle<(setPoint+128))     Drive_Motor(drive); 
  else                                                     Drive_Motor(0);     // stop motors if situation is hopeless

// *********************** loop timing control **************************
  DebugPrint();
  
  lastLoopUsefulTime = millis()-loopStartTime;
  if(lastLoopUsefulTime<STD_LOOP_TIME)         delay(STD_LOOP_TIME-lastLoopUsefulTime);
  lastLoopTime = millis() - loopStartTime;
  loopStartTime = millis();
}
