// KasBot V1  -  PID module

#define   GUARD_GAIN   20.0

float K = -1.0;
float Kp = 50;  //30                   
float Ki = 1;  //1                 
float Kd = 15;  //6
float last_error = 0;
float integrated_error = 0;
float pTerm = 0, iTerm = 0, dTerm = 0;

int updatePid(float targetPosition, float currentPosition)   {
  float error = targetPosition - currentPosition; 
  pTerm = Kp * error;
  integrated_error += error;  
  integrated_error = constrain(integrated_error, -GUARD_GAIN, GUARD_GAIN);
  iTerm = Ki * integrated_error;
  dTerm = Kd * (error - last_error);
  //dTerm = Kd * GYRO_rate;
  last_error = error;
  return -constrain(K*(pTerm + iTerm + dTerm), -255, 255);
}
